#
# Conditional build:
%bcond_without	ocaml_opt	# native optimized binaries (bytecode is always built)

%ifnarch %{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%define		module	biniou
Summary:	Flexible binary data format in OCaml
Summary(pl.UTF-8):	Elastyczny format danych binarnych dla OCamla
Name:		ocaml-%{module}
Version:	1.2.1
Release:	3
License:	BSD
Group:		Libraries
#Source0Download: https://github.com/ocaml-community/biniou/releases
Source0:	https://github.com/ocaml-community/biniou/releases/download/%{version}/%{module}-%{version}.tbz
# Source0-md5:	07e30c58975cba31cd770a8c0df20f29
URL:		https://github.com/ocaml-community/biniou
BuildRequires:	ocaml >= 1:4.02.3
BuildRequires:	ocaml-dune >= 1.10
BuildRequires:	ocaml-easy-format-devel >= 1.0.1
BuildRequires:	ocaml-findlib >= 1.4
%requires_eq	ocaml-runtime
Requires:	ocaml-easy-format >= 1.0.1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		debug_package	%{nil}

%description
Biniou is a binary data format designed for speed, safety, ease of use
and backward compatibility as protocols evolve. Biniou is vastly
equivalent to JSON in terms of functionality but allows
implementations about 4 times as fast (see godi-yojson for
comparison), with 25-35% space savings. Biniou data can be decoded
into human-readable form without knowledge of type definitions except
for field and variant names which are represented by 31-bit hashes.

%description -l pl.UTF-8
Biniou to format danych binarnych zaprojektowany z myślą o szybkości,
bezpieczeństwie, łatwym użyciu oraz zgodności wstecznej w miarę
ewolucji protokołów. Biniou pod względem funkcjonalnym jest bliskim
odpowiednikiem formatu JSON, ale pozwala na implementacje około 4 razy
szybsze (np. godi-yojson dla porównania), z oszczędnością miejsca
rzędu 25-35%. Dane Biniou mogą być dekodowane do postaci czytelnej dla
człowieka bez znajomości definicji typów, z wyjątkiem nazw pól i
wariantów, które są reprezentowane jako 31-bitowe hasze.

%package devel
Summary:	biniou binding for OCaml - development part
Summary(pl.UTF-8):	Wiązania biniou dla OCamla - cześć programistyczna
Group:		Development/Libraries
%requires_eq	ocaml
Requires:	%{name} = %{version}-%{release}
Requires:	ocaml-easy-format-devel >= 1.0.1

%description devel
Biniou is a binary data format designed for speed, safety, ease of use
and backward compatibility as protocols evolve. Biniou is vastly
equivalent to JSON in terms of functionality but allows
implementations about 4 times as fast (see godi-yojson for
comparison), with 25-35% space savings. Biniou data can be decoded
into human-readable form without knowledge of type definitions except
for field and variant names which are represented by 31-bit hashes.

This package contains files needed to develop OCaml programs using
biniou library.

%description devel -l pl.UTF-8
Biniou to format danych binarnych zaprojektowany z myślą o szybkości,
bezpieczeństwie, łatwym użyciu oraz zgodności wstecznej w miarę
ewolucji protokołów. Biniou pod względem funkcjonalnym jest bliskim
odpowiednikiem formatu JSON, ale pozwala na implementacje około 4 razy
szybsze (np. godi-yojson dla porównania), z oszczędnością miejsca
rzędu 25-35%. Dane Biniou mogą być dekodowane do postaci czytelnej dla
człowieka bez znajomości definicji typów, z wyjątkiem nazw pól i
wariantów, które są reprezentowane jako 31-bitowe hasze.

Ten pakiet zawiera pliki niezbędne do tworzenia programów używających
biblioteki biniou.

%prep
%setup -q -n %{module}-%{version}

%build
dune build --display=verbose

%install
rm -rf $RPM_BUILD_ROOT

dune install --destdir=$RPM_BUILD_ROOT

# sources
%{__rm} -r $RPM_BUILD_ROOT%{_libdir}/ocaml/%{module}/*.ml
# packaged as %doc
%{__rm} -r $RPM_BUILD_ROOT%{_prefix}/doc/%{module}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.md LICENSE README.md
%dir %{_libdir}/ocaml/%{module}
%{_libdir}/ocaml/%{module}/META
%{_libdir}/ocaml/%{module}/biniou.cma
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/%{module}/biniou.cmxs
%endif

%files devel
%defattr(644,root,root,755)
%{_libdir}/ocaml/%{module}/bi_*.cmi
%{_libdir}/ocaml/%{module}/bi_*.cmt
%{_libdir}/ocaml/%{module}/bi_*.cmti
%{_libdir}/ocaml/%{module}/bi_*.mli
%if %{with ocaml_opt}
%attr(755,root,root) %{_bindir}/bdump
%{_libdir}/ocaml/%{module}/biniou.a
%{_libdir}/ocaml/%{module}/biniou.cmxa
%{_libdir}/ocaml/%{module}/bi_*.cmx
%endif
%{_libdir}/ocaml/%{module}/dune-package
%{_libdir}/ocaml/%{module}/opam
%changelog
* Sun Sep 19 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-biniou.git;a=log;h=master

* Sun Sep 19 2021 Jan Rękorajski <baggins@pld-linux.org> 67d7d42
- Release 3 (by relup.sh)

* Thu Sep 16 2021 Jakub Bogusz <qboosh@pld-linux.org> d16a996
- cmi,cmt,cmti files seem to belong to devel part
- call dune directly instead of hiding behind make
- use arm macro
- updated ocaml version

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 43b87d9
- update META and dune files locations
- rel 2

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> 6df8017
- rel 1

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> 9ef7719
- updated files

* Sun Mar 21 2021 Jan Rękorajski <baggins@pld-linux.org> 50ef042
- fetch 1.2.1

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 5521799
- rebuild with ocaml 4.04.1
- release 7 (by relup.sh)

* Sat Mar 19 2016 Jan Rękorajski <baggins@pld-linux.org> be1aef3
- release 6 (by relup.sh)

* Fri Jul 24 2015 Jakub Bogusz <qboosh@pld-linux.org> 20df923
- revised packaging: .cma is dynlinkable too; release 5

* Wed Jul 22 2015 Jakub Bogusz <qboosh@pld-linux.org> cb1c089
- pl
- unified ocaml_opt bcond name, finished its support
- release 4 (ocaml rebuild)

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> eecf669
- rebuild with ocaml 4.02
- release 3 (by relup.sh)

* Wed Feb 19 2014 Jan Rękorajski <baggins@pld-linux.org> 4426a42
- added missing deps
- rel 2

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> 1bc94e2
- module definition moved to main package

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> 8c6d3f7
- added main package with native plugins for dynamic loading

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> 8950451
- up to 1.0.9

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> bd74132
- use make install, verbose files, enable opt

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> ac58557
- use macros

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> 7af1b8e
- new, version 1.0.8

